/* 
 * File:   vcf1.c
 * Author: Pavel
 *
 * Created on 11. dubna 2017, 14:29
 */



#pragma config FOSC = INTOSC        //  -- internal oscillator
#pragma config PLLEN = ON           //  -- PLL on
#pragma config WDTE = OFF           //  -- watchdog
#pragma config BOREN = OFF          //  -- brownout reset
#pragma config LVP =   OFF          //  -- low voltage programming off
#pragma config MCLRE  =  ON         //  -- mclear on
#pragma config PWRTE = ON           //  -- power up timer

#include <xc.h>

void main() {
    OSCCON = 0xF8; //32 MHz & PLL
    PORTA = 0;
    LATA = 0;
    PORTC = 0;
    LATC = 0;
    TRISC = 7;  
    ANSELC = 7; //RC0, RC1, RC2 analog in
    ANSELA = 0;

    OPTION_REG = 0;

    WPUC2 = 0; //pull up off
    WPUC1 = 0;
    WPUC0 = 0;

    T2CLKCON = 0;   // T2 clock Fosc/4
    T2CON = 0x80;   //T2CON ON  prescaler 1:1
    PR2 = 0x9F;     //fo = 50 kHz
    CCP1CON = 0xFC; // CCP1 PWM ON
    CCP2CON = 0xFC; // CCP2 PWM ON
    ADCON1 = 0x70;  // ADC ON  
    ADON = 1;
    DAC1CON0 = 0xA4; //DAC ON

    while (1) {
        ADCON0bits.CHS = 4; //RC0 IN
        _delay(100);
        GO = 1;
        while (GO);
        _delay(10);
        CCPR1L = ADRESL;    //RC5 PWM OUT
        CCPR1H = ADRESH;

        ADCON0bits.CHS = 5; //RC1 IN
        _delay(100);
        GO = 1;
        while (GO);
        _delay(10);

        CCPR2L = ADRESL;    //RC3 PWM OUT
        CCPR2H = ADRESH;

        ADCON0bits.CHS = 6; //RC2 IN
        _delay(100);
        GO = 1;
        while (GO);
        _delay(10);
        DAC1CON1 = ADRESH^0xFF; // RA1 REF IN, RA0 DAC OUT, inverse    
    }//while   
}//main


